#!/usr/bin/env python
# -*- coding: utf-8 -*-
from roller_border_line import BorderLine
from roller_ceramic_chip import CeramicChip
from roller_circle_punch import CirclePunch
from roller_clear_frame import ClearFrame
from roller_colored_board import ColoredBoard
from roller_drop_shadow import DropShadow
from roller_gradient_bevel import GradientBevel
from roller_jagged_edge import JaggedEdge
from roller_inlay_shadow import InlayShadow
from roller_line_fashion import LineFashion
from roller_maze_mirror import MazeMirror
from roller_rad_wave import RadWave
from roller_rounded_edge import RoundedEdge
from roller_stained_glass import StainedGlass
from roller_square_punch import SquarePunch
from roller_wire_fence import WireFence


class EffectNexus:
    """
    Create a collection of 3D Effects.

    Use to populate the 3D Effects drop-menu, and
    as a dock for launching a 3D effect function.
    """
    obj = (
            BorderLine,
            CeramicChip,
            CirclePunch,
            ClearFrame,
            ColoredBoard,
            DropShadow,
            GradientBevel,
            InlayShadow,
            JaggedEdge,
            LineFashion,
            MazeMirror,
            RadWave,
            RoundedEdge,
            SquarePunch,
            StainedGlass,
            WireFence
        )
    names = [i.name for i in obj]
