#!/usr/bin/env python
# -*- coding: utf-8 -*-
from roller_colored_button import ColoredButton


class SwitchButton(ColoredButton):
    """Use to process cell connection events."""

    def __init__(self, text, on_action, r, c, g, grid):
        """
        text: string
            text on button

        on_action: function
            Call on action.

        r: row
        c: column
        g: gtk Box-type
            widget's container which is padded

        grid: something
        """
        self.r = r / 2
        self.c = c / 2
        self.grid = grid
        self.action = on_action
        on_action = self.on_switch_action
        self.pad = g
        self.gate = 0
        ColoredButton.__init__(self, text, on_action)

    def on_switch_action(self, _):
        """
        Reverse the switch setting.

        Call the connection operator.
        """
        x = self.gate = int(not self.gate)

        self.set_label(("+", "-")[x])
        self.action[x](self.grid[self.r][self.c])
